Subject: Re: [PATCH v6 07/26] mm: Preserve the PG_arch_* flags in __split_huge_page_tail()

From: Catalin Marinas <[email-masked]>
Date: Mon, 6 Jul 2020 17:30:12 +0100

On Mon, Jul 06, 2020 at 04:16:13PM +0200, David Hildenbrand wrote:
> On 03.07.20 17:36, Catalin Marinas wrote:
> > When a huge page is split into normal pages, part of the head page flags
> > are transferred to the tail pages. However, the PG_arch_* flags are not
> > part of the preserved set.
> > 
> > PG_arch_1 is currently used by the arch code to handle cache maintenance
> > for user space (either for I-D cache coherency or for D-cache aliases
> > consistent with the kernel mapping). Since splitting a huge page does
> > not change the physical or virtual address of a mapping, additional
> > cache maintenance for the tail pages is unnecessary. Preserving the
> > PG_arch_1 flag from the head page in the tail pages would not break the
> > current use-cases.
> 
> ^ is fairly arm64 specific, no? (I remember that the semantics are
> different e.g., on s390x).

Not entirely arm64 specific. Apart from s390 and x86, I think all the
other architectures use this flag for cache maintenance (I guess they
followed the cachetlb.rst suggestion). My understanding of the s390 and
x86 is that transferring this flag from the head of a compound page to
the tail pages should not cause any issue. We don't even document
anywhere that this flag is meant to disappear on huge page splitting. I
guess no-one noticed because clearing it is relatively benign.

But if there are concerns, I'm happy to guard it with something like
__ARCH_WANT_PG_ARCH_HEAD_TAIL (I need to think of a more suggestive
name).

> > have valid tags. The absence of such flag causes the arm64 set_pte_at()
> > to clear the tags in order to avoid stale tags exposed to user or the
> > swapping out hooks to ignore the tags. Not preserving PG_arch_2 on huge
> > page splitting leads to tag corruption in the tail pages.
> 
> "currently"? I don't think so - isn't it follow-up patches in this series?

True. It used to be correct before reordering the patches prior to
posting.

-- 
Catalin

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel